﻿DeclareModule Visual
Declare Create()
Declare Free(*This)
EndDeclareModule

Module Visual

UseModule AIMP
UseModule Unknown

Structure Visual Extends UnkSctuct
  
EndStructure

EnableExplicit


Procedure GetFlags(*This.Visual)
  ProcedureReturn #AIMP_VISUAL_FLAGS_RQD_DATA_SPECTRUM
EndProcedure

Procedure Draw(*This.Visual, *Data.TAIMPVisualData)
  Spectr::SendData(@*Data\Spectrum[2]\Arr[0])
EndProcedure

Procedure Create()
  Protected *Struct.Visual
  
  *Struct = AllocateMemory(SizeOf(Visual))
  If *Struct
    InitializeStructure(*Struct, Visual)
    ;CopyMemory(AIMP::?IID_IAIMPExtensionCustomVisualization, @*Struct\IID, SizeOf(GUID))
    CopyMemory(?__IID_IAIMPExtensionCustomVisualization, @*Struct\IID, SizeOf(GUID))
    *Struct\VT = ?Proc
  EndIf
  
  ProcedureReturn *Struct
  
  DataSection
    Proc:
    Unknown::UnkProc
    Data.i @GetFlags()
    Data.i @Draw()
    
    
    __IID_IAIMPExtensionCustomVisualization:
    Data.l $41494D50
    Data.u $4578, $7443
    Data.a $73, $74, $6D, $56, $69, $73, $00, $00
    
  EndDataSection
EndProcedure

Procedure Free(*This.Visual)
  Protected Res = #False
  
  If *This
    ClearStructure(*This, Visual)
    FreeMemory(*This)
    Res = #True
  EndIf
  
  ProcedureReturn Res
EndProcedure

EndModule
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 32
; FirstLine = 15
; Folding = --
; EnableUnicode
; EnableXP